VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TFCGrafics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'*********************************************************************************
'* PROJECTE: Representaci de dades temtiques
'*
'* Fitxer: RepresentacioGrafica.bas
'* Autor: Gerard Font Juvanteny
'* Consultor: Ramon Catal
'*
'* Treball Final de Carrera
'* Curs 2011-2012, semestre I
'*********************************************************************************

Dim objCUS As CustomDataPipe
Dim objCPoint As New CenterPointPipe
Dim GeomName As String
Dim gfdField As GField
Dim rs2 As GRecordset
Dim index As Integer
Dim metode As Integer
Dim GeoApp As GeoMedia.Application
        
        
'Preparaci per a la creaci de les capes de grfics
Public Function graficGFX(tipus As Integer, pGeoApp As GeoMedia.Application, Dades() As String, nFiles As Integer, recSet As GRecordset, campLligam1 As String, campLligam2 As String, numGFX As Integer)
    Set GeoApp = pGeoApp

    'Crear CustomDataPipe
    Set objCUS = New CustomDataPipe

    'Crear els camps necessaris
    Set gfdField = objCUS.CreateField
    gfdField.Name = campLligam2
    gfdField.Type = gdbText
    objCUS.GFields.Append gfdField
    
    'obtenir Recordset
    Set rs2 = objCUS.OutputRecordset

    'Desar a Custom
    For index = 1 To nFiles
        If Trim(Dades(index, 1)) <> "" Then
            rs2.AddNew
            rs2.GFields(campLligam2).Value = Dades(index, 1)
            rs2.Update
        End If
    Next index
    
    'Buscar el nom del camp de la geometria
    GeomName = obtenirGeometryFieldName(recSet)

    'Buscar el centroide
    With objCPoint
         Set .InputRecordset = recSet
         .InputGeometryFieldName = GeomName
         .OutputGeometryFieldName = "Centroide"
    End With

    'Unir els 2 recordsets
    Dim objJN As EquijoinPipe
    Set objJN = CreateObject("GeoMedia.EquijoinPipe")
    Dim JoinFields(1, 0) As String
    JoinFields(0, 0) = campLligam1
    JoinFields(1, 0) = campLligam2

    With objJN
        Set .LeftRecordset = objCPoint.OutputRecordset
        Set .RightRecordset = rs2
        .JoinFieldNames = JoinFields
        .JoinType = gmejpInner
    End With
    
    If objJN.OutputRecordset.EOF And objJN.OutputRecordset.BOF Then
        MsgBox "No s'ha trobat cap concidncia amb els camps de lligam que has indicat"
        graficGFX = False
    Else
        'Crear l'entrada a la llegenda
        crearEntradaLlegendaGrafics objJN.OutputRecordset, campLligam2, numGFX
        graficGFX = True
    End If
End Function


'Grafic de cercles
Public Function graficCercles(pGeoApp As GeoMedia.Application, Dades() As String, nFiles As Integer, recSet As GRecordset, campLligam1 As String, campLligam2 As String, titol As String)
    Set GeoApp = pGeoApp
    
    'Crear CustomDataPipe
    Set objCUS = New CustomDataPipe

    'Crear els camps necessaris
    Set gfdField = objCUS.CreateField
    gfdField.Name = campLligam2
    gfdField.Type = gdbText
    objCUS.GFields.Append gfdField
    
    Set gfdField = objCUS.CreateField
    gfdField.Name = "VALOR"
    gfdField.Type = gdbDouble
    objCUS.GFields.Append gfdField
    
    'obtenir Recordset
    Set rs2 = objCUS.OutputRecordset

    'Desar a Custom
    For index = 1 To nFiles
        rs2.AddNew
        rs2.GFields(campLligam2).Value = Dades(index, 1)
        rs2.GFields("VALOR").Value = Val(Dades(index, 2))
        rs2.Update
    Next index
    
    'Buscar el nom del camp de la geometria
    GeomName = obtenirGeometryFieldName(recSet)

    'Buscar el centroide
    With objCPoint
         Set .InputRecordset = recSet
         .InputGeometryFieldName = GeomName
         .OutputGeometryFieldName = "Centroide"
    End With

    'Unir els 2 recordsets
    Dim objJN As EquijoinPipe
    Set objJN = CreateObject("GeoMedia.EquijoinPipe")
    Dim JoinFields(1, 0) As String
    JoinFields(0, 0) = campLligam1
    JoinFields(1, 0) = campLligam2

    With objJN
        Set .LeftRecordset = objCPoint.OutputRecordset
        Set .RightRecordset = rs2
        .JoinFieldNames = JoinFields
        .JoinType = gmejpInner
    End With


    If objJN.OutputRecordset.EOF And objJN.OutputRecordset.BOF Then
        MsgBox "No s'ha trobat cap concidncia amb els camps de lligam que has indicat"
        graficCercles = False
    Else
        'Crear l'entrada a la llegenda
        crearEntradaLlegenda objJN.OutputRecordset, "Centroide", GRAFIC_CERCLES, "Grfic de cercles (" & titol & ")"
        graficCercles = True
    End If

End Function

'Grafic de gruix
Public Function graficGruix(pGeoApp As GeoMedia.Application, Dades() As String, nFiles As Integer, recSet As GRecordset, pMetode As Integer, campLligam1 As String, campLligam2 As String, titol As String)
    Set GeoApp = pGeoApp

    'Crear CustomDataPipe
    Set objCUS = New CustomDataPipe

    'Crear els camps necessaris
    Set gfdField = objCUS.CreateField
    gfdField.Name = campLligam2
    gfdField.Type = gdbText
    objCUS.GFields.Append gfdField
    
    Set gfdField = objCUS.CreateField
    gfdField.Name = "VALOR"
    gfdField.Type = gdbDouble
    objCUS.GFields.Append gfdField
    
    'obtenir Recordset
    Set rs2 = objCUS.OutputRecordset

    'Desar a Custom
    For index = 1 To nFiles
        rs2.AddNew
        rs2.GFields(campLligam2).Value = Dades(index, 1)
        rs2.GFields("VALOR").Value = Val(Dades(index, 2))
        rs2.Update
    Next index

    'Buscar el nom del camp de la geometria
    GeomName = obtenirGeometryFieldName(recSet)

    'Unir els 2 recordsets
    Dim objJN As EquijoinPipe
    Set objJN = CreateObject("GeoMedia.EquijoinPipe")
    Dim JoinFields(1, 0) As String
    JoinFields(0, 0) = campLligam1
    JoinFields(1, 0) = campLligam2

    With objJN
        Set .LeftRecordset = recSet
        Set .RightRecordset = rs2
        .JoinFieldNames = JoinFields
        .JoinType = gmejpInner
    End With
    
    metode = pMetode

    If objJN.OutputRecordset.EOF And objJN.OutputRecordset.BOF Then
        MsgBox "No s'ha trobat cap concidncia amb els camps de lligam que has indicat"
        graficGruix = False
    Else
        'Crear l'entrada a la llegenda
        crearEntradaLlegenda objJN.OutputRecordset, GeomName, GRAFIC_GRUIX, "Grfic de gruix i lnies (" & titol & ")"
        graficGruix = True
    End If
End Function


'Crear l'entrada a la llegenda
Private Function crearEntradaLlegenda(recSet As GRecordset, geometryField As String, tipus As Integer, titol As String)
    
    'Per la llegenda
    Dim objRLE As RecordLegendEntry
    
    'Crear l'entrada a la llegenda per a la capa del grfics
    Set objRLE = GeoApp.CreateService("Geomedia.RecordLegendEntry")
                
    'Definir les propietats de l'entrada de llegenda
    With objRLE
        .GeometryFieldName = geometryField
        Set .Recordset = recSet
        .DisplayMode = gmlDisplayModeOn
        .Selected = True
        .Title = titol
        .Visible = True
    End With
        
    'Definir estil
    If tipus = GRAFIC_CERCLES Then
        crearCercles objRLE
    ElseIf tipus = GRAFIC_GRUIX Then
        crearGruix objRLE
    End If
        
    GeoApp.ActiveWindow.MapView.Legend.LegendEntries.Append objRLE, 1
    'GeoApp.ActiveWindow.MapView.Fit
    GeoApp.Document.RefreshViews

End Function

'Crear l'entrada a la llegenda per grfics
Private Function crearEntradaLlegendaGrafics(recSet As GRecordset, campCodi As String, numGFX As Integer)
    'Definir estil
    crearGFX recSet, campCodi, numGFX

    'GeoApp.ActiveWindow.MapView.Fit
    GeoApp.Document.RefreshViews

End Function

'Crea els cercles del grfic
Private Sub crearCercles(objLE As LegendEntry)
    Dim objUVColl As GMCollection
    Dim objCLESvc As New ThematicClassificationService

    Set objCLESvc.LegendEntry = objLE
    objCLESvc.AttributeFieldNames = "VALOR"
         
    'Definir l'estil
    Dim linStyle As LinearStyle
    Set linStyle = GeoApp.CreateService("Geomedia.LinearStyle")
    Set objLE.Style = linStyle
         
    'Definir la rampa de colors
    Dim objColor As ColorScheme, objColors As ColorSchemes
    Dim colors(2) As Long
    Set objColors = CreateObject("Geomedia.ColorSchemes")
    Set objColor = CreateObject("Geomedia.ColorScheme")
    colors(0) = RGB(255, 0, 0)
    colors(1) = RGB(255, 255, 255)
         
    With objColor
             .colors = colors()
             .Name = "Teal Ramp"
             .Type = gmcsRamp
    End With
    objColors.Append objColor
         
    objCLESvc.CreateRangeClasses objUVColl, gmtcsClassifyByEqualCount, 5, gmtcsIncludeOthers, , , objColors, 1, gmtcsSortAscending
    objCLESvc.ClassifyLegendEntry objUVColl
    objLE.LoadData
    
    Dim i As Integer
    'Dimensionar els punts
    For i = 1 To objLE.GroupEntries.Count
        objLE.GroupEntries(i).Style.StyleProperties(gmgroPropertySize).Value = (i * 500)
        objLE.GroupEntries(i).DisplayMode = gmlDisplayModeOn
        objLE.GroupEntries(i).LoadData
    Next i
    
    Set objColors = Nothing
    Set objColor = Nothing
    Set objUVColl = Nothing
    Set objCLESvc = Nothing

End Sub


'Crea el gruix del grfic
Private Sub crearGruix(objLE As LegendEntry)
    Dim objUVColl As GMCollection
    Dim objCLESvc As New ThematicClassificationService
         
    Set objCLESvc.LegendEntry = objLE
    objCLESvc.AttributeFieldNames = "VALOR"
         
    'Definir l'estil
    Dim areaStyle As areaStyle
    Set areaStyle = GeoApp.CreateService("Geomedia.AreaStyle")
    areaStyle.BoundaryOn = True
    Set objLE.Style = areaStyle
         
    'Definir la rampa de colors
    Dim objColor As ColorScheme, objColors As ColorSchemes
    Dim colors(5) As Long
    Set objColors = CreateObject("Geomedia.ColorSchemes")
    Set objColor = CreateObject("Geomedia.ColorScheme")
    colors(0) = RGB(226, 255, 226)
    colors(1) = RGB(225, 241, 198)
    colors(2) = RGB(192, 226, 136)
    colors(3) = RGB(159, 211, 74)
    colors(4) = RGB(119, 168, 41)
    
    With objColor
             .colors = colors()
             .Name = "Teal Ramp"
    End With
    objColors.Append objColor
         
    objCLESvc.CreateRangeClasses objUVColl, metode, 5, gmtcsIncludeOthers, , , objColors, 1, gmtcsSortAscending
    objCLESvc.ClassifyLegendEntry objUVColl
    objLE.LoadData
    
    Dim i As Integer
    'Gruix de les geometries
    For i = 1 To objLE.GroupEntries.Count
        objLE.GroupEntries(i).Style.StyleProperties(gmgroPropertyBoundary).Value = 30
        objLE.GroupEntries(i).DisplayMode = gmlDisplayModeOn
        objLE.GroupEntries(i).LoadData
    Next i
    
    Set objUVColl = Nothing
    Set objColors = Nothing
    Set objColor = Nothing
    Set objCLESvc = Nothing

End Sub


'Crea les capes de grafics
Private Sub crearGFX(recSet As GRecordset, campCodi As String, numGFX As Integer)
    Dim objVLFPipe As ValueListFilterPipe
    Dim rsFiltrat As GRecordset
    Dim marcador As String
    
    recSet.MoveFirst
    Do While Not recSet.EOF
        marcador = recSet.Bookmark
        
        Set objVLFPipe = CreateObject("GeoMedia.ValueListFilterPipe")
        Dim idAFiltrar(1) As Variant
        idAFiltrar(0) = recSet.GFields(campCodi)
        With objVLFPipe
            Set .InputRecordset = recSet
            .FilterMode = gmvlfpInclusion
            .FieldNames = campCodi
            .ValueList = idAFiltrar
            Set rsFiltrat = .OutputRecordset
        End With
                
        'Per la llegenda
        Dim objLE As RecordLegendEntry
        Set objLE = GeoApp.CreateService("Geomedia.RecordLegendEntry")
        'Definir les propietats de l'entrada de llegenda
        With objLE
            .GeometryFieldName = "Centroide"
            Set .Recordset = objVLFPipe.OutputRecordset
            .DisplayMode = gmlDisplayModeOn
            .Selected = True
            .Title = recSet.GFields(campCodi)
            .Visible = True
        End With
    
        'Definir l'estil
        Dim objStyleService As New StyleService
        Dim objstyle1 As New StyleDefinition
        objStyleService.GetStyle "Picture Style", objstyle1
        objstyle1.StyleProperties(gmgroPropertyAlignment).Value = gmgroAlignmentCenterCenter
        objstyle1.StyleProperties(gmgroPropertyOffsetX).Value = 0
        objstyle1.StyleProperties(gmgroPropertyOffsetY).Value = 0
        objstyle1.StyleProperties(gmgroPropertyRotation).Value = 0
        objstyle1.StyleProperties(gmgroPropertyRotationOption).Value = gmgroIgnoreGeometryOrientation
        objstyle1.StyleProperties(gmgroPropertySize).Value = 2460  'Punts
        objstyle1.StyleProperties(gmgroPropertyUnitType).Value = gmgroUnitTypeScalingPaper
        objstyle1.StyleProperties(gmgroPropertySource).Value = rutaCTemp & "\chart_entitat" & numGFX & "_" & recSet.GFields(campCodi) & ".bmp"
        Dim objstyle As StyleDefinition
        objStyleService.GetStyle "Picture Style", objstyle
        objstyle.StyleDefinitions.Append objstyle1
    
        Set objLE.Style = objstyle
        objLE.LoadData
        
        GeoApp.ActiveWindow.MapView.Legend.LegendEntries.Append objLE, 1
    
        recSet.Move 0, marcador
        recSet.MoveNext
        
        Set objVLFPipe = Nothing
        Set objLE = Nothing
        Set objstyle = Nothing
    Loop
    
    'GeoApp.ActiveWindow.MapView.Fit
    GeoApp.Document.RefreshViews
    
    Set objUVColl = Nothing
    Set objCLESvc = Nothing

End Sub


'Cerca el nom del camp de la geometria d'un recordset
Private Function obtenirGeometryFieldName(recSet As GRecordset)
    obtenirGeometryFieldName = ""
    Dim fld As GField
    For Each fld In recSet.GFields
        If fld.Type = PClient.GConstants.gdbSpatial Or fld.Type = PClient.GConstants.gdbGraphic Then
            obtenirGeometryFieldName = fld.Name
            Exit For
        End If
    Next
End Function

