Attribute VB_Name = "modUOCTFC"

Option Explicit
'
' This is the main module for the Command project.  It includes constants and Windows API
' declarations needed for the Command.
'

'
' Global variables
'
Global gobjGeoApp As Object

' For Help
Global Const HELP_CONTEXT = 1

'
' Declare the rectangle type for use in GetWindowRect
'
Type RectType
    iLeft As Long
    iTop As Long
    iright As Long
    ibottom As Long
End Type
'
' Declare the Windows function that allows us to center a form either on the screen
' or within the application.
'
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RectType) As Long

'
' show help
'
Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hwnd As Long, _
                                                        ByVal lpHelpFile As String, _
                                                        ByVal wCommand As Long, _
                                                        ByVal dwData As Long) As Long

' This function centers a form either on the screen if the hWndParent is 0 or within
' the parent.  Copied from VBProgrammers Journal OCT 95 and modified for our needs.
' Modified to fix TR 65341 (multiple monitors).  TJH  18-Feb-2005
Sub CenterForm(ByVal hWndParent As Long, frmForm As Form)
' hWndParent:       i - Handle to a parent window (may be 0)
' frmForm:          i - Form to be centered

    Dim iLeft As Long
    Dim iTop As Long
    Dim rcParent As RectType
    Dim dParentWidth As Double, dParentHeight As Double
    Dim dParentMidX As Double, dParentMidY As Double
  
    'If we know the parent's hwnd, the math is easy.
    If hWndParent > 0 Then
        'We could do the math all in one line but it
        'would not be as understandable.
        Call GetWindowRect(hWndParent, rcParent)
        With rcParent
            dParentWidth = CDbl(.iright - .iLeft)   'pixels
            dParentHeight = CDbl(.ibottom - .iTop)  'pixels
            'Remaining calculations in twips.
            dParentMidX = (CDbl(.iLeft) + (dParentWidth / 2#)) _
                            * CDbl(Screen.TwipsPerPixelX)
            dParentMidY = (CDbl(.iTop) + (dParentHeight / 2#)) _
                            * CDbl(Screen.TwipsPerPixelY)
        End With
        iLeft = CLng(dParentMidX - (CDbl(frmForm.Width) / 2#))
        iTop = CLng(dParentMidY - (CDbl(frmForm.Height) / 2#))
    Else
        'No parent, center over the screen using the screen object.
        'This will still cause problems in VB6 because the screen
        'object doesn't appear to know about multiple monitors.
        'VB.Net should fix it.
        iLeft = (Screen.Width / 2) - (frmForm.Width / 2)
        iTop = (Screen.Height / 2) - (frmForm.Height / 2)
    End If

    ' Move the form to its new position
    frmForm.Move iLeft, iTop
End Sub
'
' This is the main function which is the entry point for the OLE server.
' Only initialization logic which is common to all Commands in this server
' should be placed in this subroutine.
'


Sub Main()

End Sub











